// This encapsulates the state we need to know how to configure a real
// serial port.

#ifndef _INCLUDE_SERIAL_CFG_STATE_H_
#define _INCLUDE_SERIAL_CFG_STATE_H_
#define _INCLUDE_SERIAL_CFG_STATE_H_

#if 1 // using serial port
#include "ctb-0.16/serport.h"
#endif

class SerialCfgState
{
public:
    SerialCfgState();

    SerialCfgState(const SerialCfgState &obj);              // copy
    SerialCfgState &operator=(const SerialCfgState &rhs);   // assignment

    void Load(int term);          // read from configuration file
    void Save(int term) const;    // save to configuration file

    bool operator==(const SerialCfgState &rhs) const;
    bool operator!=(const SerialCfgState &rhs) const;
    SerialCfgState* clone() const;

    // accessors
    void setTtyEnable(bool enabled);
    bool getTtyEnable() const;

    void setPort(int com_port);
    int  getPort() const;

    void setBaudRate(int baud_rate);
    int  getBaudRate() const;

    void setParity(ctb::Parity mode);
    ctb::Parity getParity() const;

    void setBits(int bits_per_byte);
    int  getBits() const;

    void setStopBits(int stop_bits);
    int  getStopBits() const;

    void setFlowctl(bool rts_cts_enabled);
    bool getFlowctl() const;

    ctb::SerialPort_DCS *getDCS();

private:

    void setDefaults();

    // is a serial port associated with the terminal
    bool m_tty_enabled;

    // which port (1=com1, 2=com2, etc)
    int  m_port;

    // link settings
    ctb::SerialPort_DCS m_dcs;
};

#endif // _INCLUDE_SERIAL_CFG_STATE_H_
