#ifndef _UI_SERIAL_CONFIG_DLG_H_
#define _UI_SERIAL_CONFIG_DLG_H_

// ----------------------------------------------------------------------------
// SerialCfgDlg class definition
// ----------------------------------------------------------------------------

#include "SerialCfgState.h"

class SerialCfgDlg : public wxDialog
{
public:
    SerialCfgDlg(wxWindow *parent, SerialCfgState *cfg);
    // ~SerialCfgDlg();

private:
    wxCheckBox  *hTtyEnable;
    wxRadioBox  *hPort;
    wxRadioBox  *hBaud;
    wxRadioBox  *hParity;
    wxRadioBox  *hBits;
    wxRadioBox  *hStopbits;
    wxRadioBox  *hFlowctl;

    wxButton   *hBtnRevert;
    wxButton   *hBtnOK;
    wxButton   *hBtnCancel;

    // configuration state:
    SerialCfgState *m_oldcfg;   // the existing configuration
    SerialCfgState  m_cfg;      // the working copy

    // helper routines
    void UpdateDlg();

    // save/get dialog box geometry the ini file
    void SaveDefaults();
    void GetDefaults();

    // ---- event handlers ----
    void OnTtyEnable( wxCommandEvent& WXUNUSED(event) );
    void OnTtyPort( wxCommandEvent& WXUNUSED(event) );
    void OnTtyBaud( wxCommandEvent& WXUNUSED(event) );
    void OnTtyParity( wxCommandEvent& WXUNUSED(event) );
    void OnTtyBits( wxCommandEvent& WXUNUSED(event) );
    void OnTtyStopBits( wxCommandEvent& WXUNUSED(event) );
    void OnTtyFlowCtl( wxCommandEvent& WXUNUSED(event) );
    void OnButton(wxCommandEvent& event);

    CANT_ASSIGN_OR_COPY_CLASS(SerialCfgDlg);
    DECLARE_EVENT_TABLE()
};

#endif // _UI_SERIAL_CONFIG_DLG_H_
